#ifndef _EvalIdiomViews
#define _EvalIdiomViews

#include <cstdlib>
#include <cmath>
#include <algorithm>
#include "Functions.h"
#include "Idiom.h"
#include "View.h"
#include "Configuration.h"
#include "Constantes.h"

// fonction evaluant la qualit d'un idiome en terme de visibilite de l'objectif
// au travers chacune des vues de la hierarchie;
// on prend en parametre la liste de configurations du bras pour pouvoir realiser l'evaluation.
// + on utilise les parametres globaux donnant le type d'objectif.
void evalViews(Idiom& idiom,const vector<Configuration>& configurations);

#endif
