#include "Constantes.h"

void init() {
	RAY_STATION=100; // rayon du cylindre definissant la station (tout est en METRES !)
	RAY_STATION_2=10000; // au carre
	LONG_STATION=1000; // longueur de la station, ==hauteur du cylindre
	RAY_C=0.175; // rayon de la coupe d'un cylindre de bras
	RAY_P=0.3; // rayon de la sphere modelisant le poignet
	LONG_EC=8.5; // longueur de l'epaule au coude
	LONG_CP=8.5; // longueur du coude au poignet
	PAS_ELEM=0.5;
	COEFF_EP=5;
	COEFF_CO=5;
	COEFF_PO=1;
	MAX_DIST=100000000;
	SEUIL_TOL=0.001;
	CHAMP_POIGNET=1.0; // champ de vision du poignet (==diametre), en metres
	ANGLE_CAM=M_PI_4; // demi-angle de vue de chaque camera; valeur arbitraire a corriger.
	TAN_ANGLE=1.0;
	TAN_2_ANGLE=1.0;
	MARGE_VUE=1.4;
	SEUIL=0.001; // seuil de variation effective dans le mouvement des joints;
	EPSILON=0.2; // seuil de fusion des segments
	S_MIN=0.5;
	S_MAX=10.5;
	S_INC=1.0;
	SEUIL_OBS=3.0;
	SEUIL_DIST_OBST=5.0;
	SEUIL_LISS=3.0; // seuil == frontiere deplacement / saut
	SEUIL_PREDOM=0.4; // seuil de predominance pour depct_negligeable / depct_remarquable
	SEUIL_RAIL=2.0;
	SEUIL_VIS=0.7;
	M_PI=3.1415926535897932384626433832795;
	M_PI_2=1.5707963267948966192313216916398;
	M_PI_4=0.7853981633974483096156608458199;

	return;
}