#ifndef _FilmageFixe
#define _FilmageFixe

#include <cstdlib>
#include "ConfigCamera.h"
#include "Camera.h"
#include "Constantes.h"

// comme son nom l'indique, cette classe s'occupe du filmage de la trajectoire
// avec un jeu de cameras fixees sur la station.

class FilmageFixe {
	
public :
	
	// initialisation de la structure contenant les positions de chaque camera :
	FilmageFixe ();
	
	~FilmageFixe () {
		delete [] camerasF;
	}
	
	// obtention des configurations de cameras pour l'image courante :
	void getCamConfig(ConfigCamera* resConfigs);
	
	Camera* camerasF;

};

#endif
