#include "IdiomBase.h"

// construction de la base d'idiomes
void buildIdiomsBase() {
	
	Idiom id;
	
	/************************************************************************************
	* premiers idiomes en accord avec methode selon mouvements du bras (voir memoire) :
	************************************************************************************/

	// shot static :
	id.name="static";
	id.shots.clear();
	id.shots.push_back(Shot(0));
	idiomsBase.push_back(id);
	
	// shot pan horizontal :
	id.name="panHori";
	id.shots.clear();
	id.shots.push_back(Shot(1));
	idiomsBase.push_back(id);
	
	// shot pan vertical :
	id.name="panVert";
	id.shots.push_back(Shot(2));
	idiomsBase.push_back(id);
	
	// shot track (le long du rail) :
	id.name="track";
	id.shots.clear();
	id.shots.push_back(Shot(3));
	idiomsBase.push_back(id);
	
	// l'idiome indetermine (utile pr la transformation config->idiomes->film
	id.name="unknown";
	id.shots.clear();
	id.shots.push_back(Shot(0));
	idiomsBase.push_back(id);
	
	/********************************************************************
	* autres idiomes : utiles pr la methode avec decoupage en couloirs.
	*********************************************************************/
/*
	// type 0 : static et go-by (mme mouvement de la camera)
	id.name="fixedCam";
	id.shots.push_back(Shot(0));
	idiomsBase.push_back(id);
	
	// type 1: pan
	id.name="panning";
	id.shots.clear();
	id.shots.push_back(Shot(1));
	idiomsBase.push_back(id);

	// type 2: track
	id.name="tracking";
	id.shots.clear();
	id.shots.push_back(Shot(2));
	idiomsBase.push_back(id);

	// type 3: pan puis track
	id.name="panThenTrack";
	id.shots.clear();
	id.shots.push_back(Shot(1));
	id.shots.push_back(Shot(2));
	idiomsBase.push_back(id);

	// type 4: follow (vue ~orthogonale au plan du bras dans le sens de deplacement)
	id.name="following";
	id.shots.clear();
	id.shots.push_back(Shot(3));
	idiomsBase.push_back(id);
	
	// type 5: pan puis follow
	id.name="panThenFollow";
	id.shots.clear();
	id.shots.push_back(Shot(1));
	id.shots.push_back(Shot(3));
	idiomsBase.push_back(id);
	
	// type 6: vue aerienne globale
	id.name="airView";
	id.shots.clear();
	id.shots.push_back(Shot(4));
	idiomsBase.push_back(id);
*/

	// ....etc (inacheve, a corriger / completer)
}
