#ifndef _View
#define _View

#include <cstdlib>
#include "Camera.h"
#include "Global.h"
#include "Functions.h"

// classe pour valuer la vue obtenue aprs (hypothetique) placement initial de la camera

// LEXIQUE DES VUES :

// 0 et 1 : orthogonal au plan forme par les 3 joints principaux

// 2 et 3 : parallele a l'axe Oy

// 4 et 5 : vue 3/4 de cote au dessus du bras

// 6 : vue aerienne

// 7 : vue face au bras.

// renvoit un reel entre 0 et 1 indiquant la visibilite pour cette vue avec cette camera :
// retourne la position calculee dans positionCam
double testView(Camera& cam,int indexView);

// fonction placant la camera dans la vue demandee :
void putCamInView(Camera& cam,int indexView);

#endif
