#ifndef CAMERA_H
#define CAMERA_H

#include "mpkGUI.h"
#include "visible.h"

typedef struct{
	float xP, yP, zP;
	float xO, yO, zO;
	float angle;
}Camera_t;

class camera{
public:

	static void set_camParam(SoPerspectiveCamera* cam, float xPos, float yPos, float zPos, float xOr, float yOr, float zOr, float angle,
				 float aR, float nD, float faD, float foD, float hA);

    static void which_cam(int fenetre, float xPos, float yPos, float zPos, float xOr, float yOr, float zOr, float angle,
			   float aR, float nD, float faD, float foD, float hA);

	static void print_camera(SoPerspectiveCamera* cam, char* fname);
	static void print_camera(SoPerspectiveCamera* cam);
	static void set_cam(SoPerspectiveCamera* cam, char *fname);

	static void get_camera(SoPerspectiveCamera* cam, float xP, float yP, float zP, float xO, float yO, float zO, float angle);

};

#endif