#include "interface.h"

HINSTANCE interfaceGUI::hInstance;
int interfaceGUI::compteur;

HWND interfaceGUI::hwnd;
HWND interfaceGUI::hwndChild1;
HWND interfaceGUI::hwndChild2;
HWND interfaceGUI::hwndChild3;
HWND interfaceGUI::hwndAnim;
HWND interfaceGUI::boutonChangementFenetre;
HWND interfaceGUI::boutonCamera;
HWND interfaceGUI::hwndActivation;

// 20 boutons pour 20 cameras
HWND interfaceGUI::bouton1;
HWND interfaceGUI::bouton2;
HWND interfaceGUI::bouton3;
HWND interfaceGUI::bouton4;
HWND interfaceGUI::bouton5;
HWND interfaceGUI::bouton6;
HWND interfaceGUI::bouton7;
HWND interfaceGUI::bouton8;
HWND interfaceGUI::bouton9;
HWND interfaceGUI::bouton10;
HWND interfaceGUI::bouton11;
HWND interfaceGUI::bouton12;
HWND interfaceGUI::bouton13;
HWND interfaceGUI::bouton14;
HWND interfaceGUI::bouton15;
HWND interfaceGUI::bouton16;
HWND interfaceGUI::bouton17;
HWND interfaceGUI::bouton18;
HWND interfaceGUI::bouton19;
HWND interfaceGUI::bouton20;
HWND interfaceGUI::formode;

HWND interfaceGUI::hwndup;
HWND interfaceGUI::hwnddown;
HWND interfaceGUI::hwndright;
HWND interfaceGUI::hwndleft;
HWND interfaceGUI::hwndplus;
HWND interfaceGUI::hwndmoins;
HWND interfaceGUI::hwndNumS;
HWND interfaceGUI::hwndSNum;
HWND interfaceGUI::hwndListeWind;
HWND interfaceGUI::hwndListeWindow;
HWND interfaceGUI::hwndTimeShot;

HWND interfaceGUI::hwndMovieGenerator;
HWND interfaceGUI::hwndPathPlanner;

int interfaceGUI::traite;

float interfaceGUI::dist;
float interfaceGUI::angle;
float interfaceGUI::length;
SbMatrix interfaceGUI::mx;
SbVec3f interfaceGUI::dir;

HMENU interfaceGUI::menuPrincipal;
LRESULT interfaceGUI::cam;

//Pour recuperer les champs de movie generator
char interfaceGUI::win[10];
int interfaceGUI::win1;
char interfaceGUI::ns[10];
int interfaceGUI::ns1;
char interfaceGUI::sn[10];
int interfaceGUI::sn1;
char interfaceGUI::cs[20];
int interfaceGUI::cs1;
char interfaceGUI::ts[10];
int interfaceGUI::ts1;

//Pour stocker les param du fichier animation
int* interfaceGUI::camAnim;
int* interfaceGUI::timeAnim;
int* interfaceGUI::window;
ofstream interfaceGUI::f;

WNDPROC interfaceGUI::orgbuttonproc1;
WNDPROC interfaceGUI::orgbuttonproc2;
WNDPROC interfaceGUI::orgbuttonproc3;
WNDPROC interfaceGUI::orgbuttonproc4;
WNDPROC interfaceGUI::orgbuttonproc5;
WNDPROC interfaceGUI::orgbuttonproc6;
WNDPROC interfaceGUI::orgbuttonproc7;
WNDPROC interfaceGUI::orgbuttonproc8;
WNDPROC interfaceGUI::orgbuttonproc9;
WNDPROC interfaceGUI::orgbuttonproc10;
WNDPROC interfaceGUI::orgbuttonproc11;
WNDPROC interfaceGUI::orgbuttonproc12;
WNDPROC interfaceGUI::orgbuttonproc13;
WNDPROC interfaceGUI::orgbuttonproc14;
WNDPROC interfaceGUI::orgbuttonproc15;
WNDPROC interfaceGUI::orgbuttonproc16;
WNDPROC interfaceGUI::orgbuttonproc17;
WNDPROC interfaceGUI::orgbuttonproc18;
WNDPROC interfaceGUI::orgbuttonproc19;
WNDPROC interfaceGUI::orgbuttonproc20;
WNDPROC interfaceGUI::orgbuttonprocfmod;
WNDPROC interfaceGUI::orgbuttonprocFen;
WNDPROC interfaceGUI::orgbuttonprocCam;
WNDPROC interfaceGUI::orgbuttonprocZoom;
WNDPROC interfaceGUI::orgprocMenu;
WNDPROC interfaceGUI::orgUp;
WNDPROC interfaceGUI::orgDown;
WNDPROC interfaceGUI::orgRight;
WNDPROC interfaceGUI::orgLeft;
WNDPROC interfaceGUI::orgPlus;
WNDPROC interfaceGUI::orgMoins;

void interfaceGUI::init()
{
	compteur = 1;
	traite = 0;
}

void interfaceGUI::traiteCreate(char* ns){
	//on transforme la chaine en nombre
	ns1 = atoi(ns);
	if(ns1 == 0)ShowWindow(hwndMovieGenerator, SW_HIDE);
	else{
		SetWindowText(hwndSNum, "1");
		UpdateWindow(hwndSNum);
	}
	//on marque qu'une animation a ete cree
	traite = 1;
}

LRESULT CALLBACK interfaceGUI::pathPlanner(HWND Dlg,UINT message,WPARAM wParam,LPARAM lParam)
{
	int Select;
   switch(message)
   {
   case WM_COMMAND:
      Select=LOWORD(wParam);
      switch(Select)
      {
      case IDCLAUNCH:
		  printf("lance\n");
         return TRUE;
	  case IDCCANCEL:
		 printf("cancel\n");
		 EndDialog(Dlg,Select);
         return TRUE;
	 }
   case WM_CLOSE:
	   DestroyWindow(Dlg);
	   break;
   default:
	  return FALSE;
   }
}
				
LRESULT CALLBACK interfaceGUI::movieGenerator(HWND Dlg,UINT message,WPARAM wParam,LPARAM lParam)
{
   int Select;
   switch(message)
   {
   case WM_COMMAND:
      Select=LOWORD(wParam);
      switch(Select)
      {
      case IDPLAY:
         ShowWindow(hwndMovieGenerator, SW_HIDE);
		 camAnim = new int[ns1];
		 timeAnim = new int[ns1];
		 window = new int[ns1];
		 movieGenerator::readFile("animation.txt", window, camAnim, timeAnim, ns1);
		 movieGenerator::makeAnim(hwndAnim, window, camAnim, timeAnim, ns1);
		 traite = 0;
         return TRUE;
	  case IDCSAVE:
		  //on recupere tous les champs
		  GetWindowText(hwndSNum, sn, 10);
		  sn1 = atoi(sn);
		  if(sn1 > ns1)printf("over shot\n");
		  else{
			  sn1++;
			  if(sn1 <= ns1)SetWindowText(hwndSNum, itoa(sn1, sn, 10));
			  UpdateWindow(hwndSNum);
			  GetWindowText(hwndListeWindow, win, 10);
              GetWindowText(hwndListeWind, cs, 20);
              GetWindowText(hwndTimeShot, ts, 10);
			  win1 = movieGenerator::getWin(win);
              cs1 = movieGenerator::getCam(cs);
			  ts1 = movieGenerator::getTime(ts);
			  movieGenerator::writeFile(win1, cs1, ts1);
		  }
		  return TRUE;
      case IDCCANCEL:
		  traite = 0;
		 EndDialog(Dlg,Select);
         return TRUE;
	  case IDCCREATE:
		  if(traite == 0){
              GetWindowText(hwndNumS, ns, 10);
			  traiteCreate(ns);
		  }
		 return TRUE;
	  case IDCNUMSHOT:
          return TRUE;
	  case IDCSHOTNUM:
          return TRUE;
	  case IDCCAMSEL:
          return TRUE;
	  case IDCWINSEL:
          return TRUE;
	  case IDCTIME:
          return TRUE;
	}
   case WM_CLOSE:
	   DestroyWindow(Dlg);
	   break;
   default:
	  return FALSE;
   }
}


LRESULT APIENTRY interfaceGUI::evenementproc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam){
	int wmId, wmEvent;
	
    if (uMsg == WM_COMMAND){
		wmId    = LOWORD(wParam); 
		wmEvent = HIWORD(wParam);

		switch (wmId)
		{

		case IDC_TASK:
			//on recupere la position courante du curseur ou on construit le sous menu
			HMENU ssMenuTask;
			POINT pt1;
			GetCursorPos(&pt1);
			ssMenuTask = CreatePopupMenu();
			AppendMenu(ssMenuTask, MF_STRING, IDC_PM, "Payload Move...");
			AppendMenu(ssMenuTask, MF_SEPARATOR, NULL, NULL);
			AppendMenu(ssMenuTask, MF_STRING, IDC_PMGT, "Go to");
			AppendMenu(ssMenuTask, MF_STRING, IDC_FP, "Follow Plan");
			AppendMenu(ssMenuTask, MF_SEPARATOR, NULL, NULL);
			AppendMenu(ssMenuTask, MF_STRING, IDC_I, "Inspect");
			AppendMenu(ssMenuTask, MF_STRING, IDC_SA, "Spatial awareness");
			AppendMenu(ssMenuTask, MF_SEPARATOR, NULL, NULL);
			AppendMenu(ssMenuTask, MF_STRING, IDC_S, "Show");
			AppendMenu(ssMenuTask, MF_STRING, IDC_SGT, "Show and go to");
			AppendMenu(ssMenuTask, MF_STRING, IDC_SAD, "....");
			AppendMenu(ssMenuTask, MF_SEPARATOR, NULL, NULL);
			AppendMenu(ssMenuTask, MF_STRING, IDC_R, "Repair");
			TrackPopupMenu(ssMenuTask, TPM_VERPOSANIMATION, pt1.x, pt1.y, 0, hwnd, NULL);
			break;
		case IDC_MODES:
			HMENU ssMenuModes;
			POINT pt2;
			GetCursorPos(&pt2);
			ssMenuModes = CreatePopupMenu();
			AppendMenu(ssMenuModes, MF_STRING, IDC_L, "Libre");
			AppendMenu(ssMenuModes, MF_STRING, IDC_A, "Assiste");
			TrackPopupMenu(ssMenuModes, TPM_VERPOSANIMATION, pt2.x, pt2.y, 0, hwnd, NULL);
			break;
		case IDC_ASK:
			HMENU ssMenuAsk;
			POINT pt3;
			GetCursorPos(&pt3);
			ssMenuAsk = CreatePopupMenu();
			AppendMenu(ssMenuAsk, MF_STRING, IDC_HT, "How to...");
			AppendMenu(ssMenuAsk, MF_SEPARATOR, NULL, NULL);
			AppendMenu(ssMenuAsk, MF_STRING, IDC_HTGT, "Go to");
			AppendMenu(ssMenuAsk, MF_STRING, IDC_HTA, "Avoid");
			AppendMenu(ssMenuAsk, MF_STRING, IDC_HTGTZ, "Go through zone");
			AppendMenu(ssMenuAsk, MF_STRING, IDC_HTS, "See");
			AppendMenu(ssMenuAsk, MF_SEPARATOR, NULL, NULL);
			AppendMenu(ssMenuAsk, MF_STRING, IDC_WI, "What if...");
			AppendMenu(ssMenuAsk, MF_SEPARATOR ,NULL , NULL);
			AppendMenu(ssMenuAsk, MF_STRING, IDC_WIA, "Action");
			AppendMenu(ssMenuAsk, MF_STRING, IDC_WIS, "Sequence");
			AppendMenu(ssMenuAsk, MF_SEPARATOR, NULL, NULL);
			AppendMenu(ssMenuAsk, MF_STRING, IDC_WN, "Why not...");
			AppendMenu(ssMenuAsk, MF_STRING, IDC_W, "What...");
			TrackPopupMenu(ssMenuAsk, TPM_VERPOSANIMATION, pt3.x, pt3.y, 0, hwnd, NULL);
			break;
		case IDC_TOOLS:
			HMENU ssMenuTools;
			POINT pt4;
			GetCursorPos(&pt4);
			ssMenuTools = CreatePopupMenu();
			AppendMenu(ssMenuTools, MF_STRING, IDC_PP, "Path planner");
			AppendMenu(ssMenuTools, MF_STRING, IDC_MG, "Movie generator");
			AppendMenu(ssMenuTools, MF_STRING, IDC_TE, "Task editor");
			AppendMenu(ssMenuTools, MF_STRING, IDC_CS, "Camera selector");
			TrackPopupMenu(ssMenuTools, TPM_VERPOSANIMATION, pt4.x, pt4.y, 0, hwnd, NULL);
			break;
		case IDC_PM:
			break;
		case IDC_SA:
            break;
		case IDC_HT:
			break;
		case IDC_WI:
			break;
		case IDC_MG:
			hwndMovieGenerator = CreateDialog(hInstance, (LPCTSTR)IDD_MOVIE_GENERATOR, hwnd, (DLGPROC)movieGenerator);

            hwndNumS = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW, "EDIT", "", WS_VISIBLE|WS_CHILD|ES_AUTOHSCROLL|ES_NOHIDESEL, 175, 50, 40, 25, hwndMovieGenerator, (HMENU)IDCNUMSHOT, hInstance, NULL);

			hwndSNum = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW, "EDIT", "", WS_VISIBLE|WS_CHILD|ES_AUTOHSCROLL|ES_NOHIDESEL, 175, 100, 40, 25, hwndMovieGenerator, (HMENU)IDCSHOTNUM, hInstance, NULL);

			hwndListeWindow = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW, "COMBOBOX", "", WS_VISIBLE|WS_CHILD|CBS_AUTOHSCROLL|\
            CBS_DISABLENOSCROLL|CBS_HASSTRINGS|CBS_SORT|CBS_DROPDOWN, 175, 145, 120, 300, hwndMovieGenerator, (HMENU)IDCWINSEL,
            hInstance, NULL);
			SendMessage(hwndListeWindow, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"Left");
			SendMessage(hwndListeWindow, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"Middle");
			SendMessage(hwndListeWindow, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"Right");

			hwndListeWind = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW, "COMBOBOX", "", WS_VISIBLE|WS_CHILD|CBS_AUTOHSCROLL|\
            CBS_DISABLENOSCROLL|CBS_HASSTRINGS|CBS_SORT|CBS_DROPDOWN, 175, 185, 120, 300, hwndMovieGenerator, (HMENU)IDCWINSEL,
            hInstance, NULL);
            SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"EE");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"WE");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"SE");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"Lab Top");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"Lab Bottom");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"Lab Back");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"SPP Front");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"SPP Back");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"ZCM Front");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"ZCM Back");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"SP Right Front");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"SP Right Back");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"SP Left Front");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"SP Left Back");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"SM Top");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"SM Bottom");
			SendMessage(hwndListeWind, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)"Inspector");

			hwndTimeShot = CreateWindowEx(WS_EX_OVERLAPPEDWINDOW, "EDIT", "", WS_VISIBLE|WS_CHILD|ES_AUTOHSCROLL|ES_NOHIDESEL, 175, 230, 40, 25, hwndMovieGenerator, (HMENU)IDCTIME, hInstance, NULL);

			ShowWindow(hwndMovieGenerator, SW_SHOW);
			break;
		case IDC_PP:
			printf("path planner\n");
			hwndPathPlanner = CreateDialog(hInstance, (LPCTSTR)IDD_PATH_PLANNER, hwnd, (DLGPROC)pathPlanner);
			ShowWindow(hwndPathPlanner, SW_SHOW);
			break;
		case IDC_BUTTON:
			camera::which_cam(compteur, 569.261, -1064.881, 136.206, -0.701, -0.537, -0.467, 4.366, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON2:
			camera::which_cam(compteur, -748.062, 68.959, 966.803, -0.296, 0.487, 0.821, 3.717, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON3:
			camera::which_cam(compteur, -50.777, 215.241, 515.984, 0.067, -0.584, -0.808, 3.055, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON4:
			camera::which_cam(compteur, -116.382, 1431.658, 127.537, -0.027, -0.692, -0.721, 3.142, 1.0, 0.1, 0.1, 0.1, 0.5);
            break;
		case IDC_BUTTON5:
			 camera::which_cam(compteur, 580.308, -242.302, -486.075, -0.955, 0.206, -0.210, 2.112, 1.0, 0.1, 0.1, 0.1, 0.5);
			 break;
		case IDC_BUTTON6:
			camera::which_cam(compteur, -1282.575, 6.707, 1164.792, 0.434, -0.547, -0.714, 1.737, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON7:
			camera::which_cam(compteur, -397.189, -1096.033, -147.606, 0.547, 0.755, -0.360, 3.590, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON8:
			camera::which_cam(compteur, 254.339, -659.105, 85.275, 0.970, -0.184, 0.156, 4.487, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON9:
			camera::which_cam(compteur, 149.733, 80.939, 596.116, 0.003, -0.570, -0.821, 3.752, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON10:
			camera::which_cam(compteur, 366.834, -84.078, 735.182, -0.729, 0.067, -0.680, 1.390, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON11:
			camera::which_cam(compteur, -315.883, -1063.639, -71.936, -0.143, -0.831, -0.536, 2.734, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON12:
			camera::which_cam(compteur, -200.344, 1719.050, 534.916, 0.193, 0.601, 0.775, 3.484, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON13:
			camera::which_cam(compteur, -161.232, 1651.020, 556.812, -0.043, -0.580, -0.812, 2.910, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON14:
			camera::which_cam(compteur, -174.818, -59.707, 305.183, -0.995, 0.092, 0.025, 4.720, 1.0, 0.1, 0.1, 0.1, 0.5);
            break;
		case IDC_BUTTON15:
			camera::which_cam(compteur, -1172.287, 33.085, -973.079, 0.670, 0.678, -0.300, 3.738, 1.0, 0.1, 0.1, 0.1, 0.5);
			break;
		case IDC_BUTTON16:
			camera::which_cam(compteur, -353.586, -8.034, -106.688, -0.655, 0.672, -0.344, 2.508, 1.0, 0.1, 0.1, 0.1, 0.5);
            break;
		case IDC_BUTTON17:
			camera::which_cam(compteur, -102.156, -1394.766, -205.877, -0.187, -0.737, 0.649, 3.465, 1.0, 0.1, 0.1, 0.1, 0.5);
            break;
		case IDC_BUTTON18:
			printf("Not assigned\n");
			break;
		case IDC_BUTTON19:
			printf("Not assigned\n");
			break;
		case IDC_BUTTON20:
			printf("Not assigned\n");
			break;
		case IDC_BUTTON_FOR_MODE:
			printf("for mode\n");
			break;
		case IDC_BUTTONFEN:
			switch(compteur){
				  case 1:
					  SwitchToThisWindow(hwndChild2, true);
					  MoveWindow(hwndActivation,600,455,110,21,true);
					  compteur++;
					  break;
				  case 2:
					  SwitchToThisWindow(hwndChild3, true);
					  MoveWindow(hwndActivation,1000,455,110,21,true);
					  compteur++;
					  break;
				  case 3:
					  SwitchToThisWindow(NULL, true);
					  MoveWindow(hwndActivation,1450,455,110,21,true);
					  compteur++;
					  break;
				  case 4:
					  SwitchToThisWindow(hwndChild1, true);
					  MoveWindow(hwndActivation,150,455,110,21,true);
					  compteur = 1;
					  break;
				  default:
					  printf("pb dans le changement de fenetre: cf fmstudio.cpp\n");
			  }
			break;
		case IDC_CAM:
			switch(compteur){
				  case 1:
					  camera::print_camera(mpkGUI::rootCamera1);
					  break;
				  case 2:
					  camera::print_camera(mpkGUI::rootCamera2);
					  break;
				  case 3:
					  camera::print_camera(mpkGUI::rootCamera3);
					  break;
				  default:
					  printf("Aucune Camera active\n");
			  }
			break;
		case IDC_UP:
			switch(compteur){
				  case 1:
					  mx = mpkGUI::rootCamera1->orientation.getValue();
					  dir.setValue(mx[1][0], mx[1][1], mx[1][2]);
                      mpkGUI::rootCamera1->position = mpkGUI::rootCamera1->position.getValue() + 3.0 * dir;
					  break;
				  case 2:
					  mx = mpkGUI::rootCamera2->orientation.getValue();
					  dir.setValue(mx[1][0], mx[1][1], mx[1][2]);
                      mpkGUI::rootCamera2->position = mpkGUI::rootCamera2->position.getValue() + 3.0 * dir;
					  break;
				  case 3:
					  mx = mpkGUI::rootCamera3->orientation.getValue();
					  dir.setValue(mx[1][0], mx[1][1], mx[1][2]);
                      mpkGUI::rootCamera3->position = mpkGUI::rootCamera3->position.getValue() + 3.0 * dir;
					  break;
				  default:
					  printf("Pb changement de UP\n");
			  }
			break;
		case IDC_DOWN:
			switch(compteur){
				  case 1:
					  mx = mpkGUI::rootCamera1->orientation.getValue();
					  dir.setValue(-mx[1][0], -mx[1][1], -mx[1][2]);
                      mpkGUI::rootCamera1->position = mpkGUI::rootCamera1->position.getValue() + 3.0 * dir;
					  break;
				  case 2:
					  mx = mpkGUI::rootCamera2->orientation.getValue();
					  dir.setValue(-mx[1][0], -mx[1][1], -mx[1][2]);
                      mpkGUI::rootCamera2->position = mpkGUI::rootCamera2->position.getValue() + 3.0 * dir;
					  break;
				  case 3:
					  mx = mpkGUI::rootCamera3->orientation.getValue();
					  dir.setValue(-mx[1][0], -mx[1][1], -mx[1][2]);
                      mpkGUI::rootCamera3->position = mpkGUI::rootCamera3->position.getValue() + 3.0 * dir;
					  break;
				  default:
					  printf("Pb changement de DOWN\n");
			  }
			break;
		case IDC_RIGHT:
			switch(compteur){
				  case 1:
					  mx = mpkGUI::rootCamera1->orientation.getValue();
					  dir.setValue(mx[0][0], mx[0][1], mx[0][2]);
                      mpkGUI::rootCamera1->position = mpkGUI::rootCamera1->position.getValue() + 3.0 * dir;
					  break;
				  case 2:
					  mx = mpkGUI::rootCamera2->orientation.getValue();
					  dir.setValue(mx[0][0], mx[0][1], mx[0][2]);
                      mpkGUI::rootCamera2->position = mpkGUI::rootCamera2->position.getValue() + 3.0 * dir;
					  break;
				  case 3:
					  mx = mpkGUI::rootCamera3->orientation.getValue();
					  dir.setValue(mx[0][0], mx[0][1], mx[0][2]);
                      mpkGUI::rootCamera3->position = mpkGUI::rootCamera3->position.getValue() + 3.0 * dir;
					  break;
				  default:
					  printf("Pb changement de RIGHT\n");
			  }
			break;
		case IDC_LEFT:
			switch(compteur){
				  case 1:
					  mx = mpkGUI::rootCamera1->orientation.getValue();
					  dir.setValue(-mx[0][0], -mx[0][1], -mx[0][2]);
                      mpkGUI::rootCamera1->position = mpkGUI::rootCamera1->position.getValue() + 3.0 * dir;
					  break;
				  case 2:
					  mx = mpkGUI::rootCamera2->orientation.getValue();
					  dir.setValue(-mx[0][0], -mx[0][1], -mx[0][2]);
                      mpkGUI::rootCamera2->position = mpkGUI::rootCamera2->position.getValue() + 3.0 * dir;
					  break;
				  case 3:
					  mx = mpkGUI::rootCamera3->orientation.getValue();
					  dir.setValue(-mx[0][0], -mx[0][1], -mx[0][2]);
                      mpkGUI::rootCamera3->position = mpkGUI::rootCamera3->position.getValue() + 3.0 * dir;
					  break;
				  default:
					  printf("Pb changement de LEFT\n");
			  }
			break;
		case IDC_ZOOM_IN:
			switch(compteur){
				  case 1:
					  mpkGUI::rootCamera1->heightAngle = mpkGUI::rootCamera1->heightAngle.getValue() - 0.01;
					  break;
				  case 2:
					  mpkGUI::rootCamera2->heightAngle = mpkGUI::rootCamera2->heightAngle.getValue() - 0.01;
					  break;
				  case 3:
					  mpkGUI::rootCamera3->heightAngle = mpkGUI::rootCamera3->heightAngle.getValue() - 0.01;
					  break;
				  default:
					  printf("Pb changement de zoom in\n");
			  }
			break;
		case IDC_ZOOM_OUT:
			switch(compteur){
				  case 1:
					  mpkGUI::rootCamera1->heightAngle = mpkGUI::rootCamera1->heightAngle.getValue() + 0.01;
					  break;
				  case 2:
					  mpkGUI::rootCamera2->heightAngle = mpkGUI::rootCamera2->heightAngle.getValue() + 0.01;
					  break;
				  case 3:
					  mpkGUI::rootCamera3->heightAngle = mpkGUI::rootCamera3->heightAngle.getValue() + 0.01;
					  break;
				  default:
					  printf("Pb changement de zoom out\n");
			  }
			break;
		default:
			printf("probleme dans les venements\n");
		}
	}
	
	return CallWindowProc(orgprocMenu, hwnd, uMsg, wParam, lParam);
}

void interfaceGUI::createAll(HWND hwnd)
{
	//Cration des menu
	interfaceGUI::menuPrincipal = CreateMenu();
	
	AppendMenu(menuPrincipal, MF_STRING, IDC_TASK, "Task");
	AppendMenu(menuPrincipal, MF_STRING, IDC_MODES, "Modes");
	AppendMenu(menuPrincipal, MF_STRING, IDC_ASK, "Ask");
	AppendMenu(menuPrincipal, MF_STRING, IDC_TOOLS, "Tools");

    SetMenu(hwnd, menuPrincipal);
	orgprocMenu = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);

	//creation des fenetres filles
	hwndActivation = CreateWindowEx(WS_EX_CLIENTEDGE, "STATIC", "INITIALISATION", WS_VISIBLE|WS_CHILD, 0, 0, 100, 25, hwnd, 0, hInstance, 0);
	MoveWindow(hwndActivation, 150, 455, 110, 21, true);

	hwndChild1 = CreateWindowEx(WS_EX_CLIENTEDGE, "STATIC", "", WS_VISIBLE|WS_CHILD, 7, 20, 420, 430, hwnd, 0, hInstance, 0);
	hwndChild2 = CreateWindowEx(WS_EX_CLIENTEDGE, "STATIC", "", WS_VISIBLE|WS_CHILD, 434, 20, 420, 430, hwnd, 0, hInstance, 0);
	hwndChild3 = CreateWindowEx(WS_EX_CLIENTEDGE, "STATIC", "", WS_VISIBLE|WS_CHILD, 861, 20, 420, 430, hwnd, 0, hInstance, 0);

	hwndAnim = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", "", WS_VISIBLE|WS_CHILD, 5, 500, 420, 300, hwnd, 0, hInstance, 0);
	//ShowWindow(hwndAnim, SW_HIDE);
    
	boutonChangementFenetre = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "Change Window", WS_VISIBLE|WS_CHILD, 440, 490, 180, 30, hwnd, (HMENU)IDC_BUTTONFEN, hInstance, 0);
	orgbuttonprocFen = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);

	boutonCamera = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "Display Current Camera", WS_VISIBLE|WS_CHILD, 630, 490, 180, 30, hwnd, (HMENU)IDC_CAM, hInstance, 0);
	orgbuttonprocCam = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);

	//Creation des 20 boutons
	bouton1 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "EE", WS_VISIBLE|WS_CHILD, 440, 550, 150, 30, hwnd, (HMENU)IDC_BUTTON, hInstance, 0);
	orgbuttonproc1 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton2 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "WE", WS_VISIBLE|WS_CHILD, 590, 550, 150, 30, hwnd, (HMENU)IDC_BUTTON2, hInstance, 0);
	orgbuttonproc2 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton3 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "SE", WS_VISIBLE|WS_CHILD, 740, 550, 150, 30, hwnd, (HMENU)IDC_BUTTON3, hInstance, 0);
	orgbuttonproc3 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton4 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "Lab Top", WS_VISIBLE|WS_CHILD, 890, 550, 150, 30, hwnd, (HMENU)IDC_BUTTON4, hInstance, 0);
	orgbuttonproc4 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	
	bouton5 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "Lab Bottom", WS_VISIBLE|WS_CHILD, 440, 580, 150, 30, hwnd, (HMENU)IDC_BUTTON5, hInstance, 0);
	orgbuttonproc5 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton6 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "Lab Back", WS_VISIBLE|WS_CHILD, 590, 580, 150, 30, hwnd, (HMENU)IDC_BUTTON6, hInstance, 0);
	orgbuttonproc6 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton7 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "SPP Front", WS_VISIBLE|WS_CHILD, 740, 580, 150, 30, hwnd, (HMENU)IDC_BUTTON7, hInstance, 0);
	orgbuttonproc7 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton8 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "SPP Back", WS_VISIBLE|WS_CHILD, 890, 580, 150, 30, hwnd, (HMENU)IDC_BUTTON8, hInstance, 0);
	orgbuttonproc8 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	
	bouton9 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "ZCM Front", WS_VISIBLE|WS_CHILD, 440, 610, 150, 30, hwnd, (HMENU)IDC_BUTTON9, hInstance, 0);
	orgbuttonproc9 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton10 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "ZCM Back", WS_VISIBLE|WS_CHILD, 590, 610, 150, 30, hwnd, (HMENU)IDC_BUTTON10, hInstance, 0);
	orgbuttonproc10 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton11 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "SP Right Front", WS_VISIBLE|WS_CHILD, 740, 610, 150, 30, hwnd, (HMENU)IDC_BUTTON11, hInstance, 0);
	orgbuttonproc11 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton12 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "SP Right Back", WS_VISIBLE|WS_CHILD, 890, 610, 150, 30, hwnd, (HMENU)IDC_BUTTON12, hInstance, 0);
	orgbuttonproc12 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	
	bouton13 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "SP Left Front", WS_VISIBLE|WS_CHILD, 440, 640, 150, 30, hwnd, (HMENU)IDC_BUTTON13, hInstance, 0);
	orgbuttonproc13 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton14 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "SP Left Back", WS_VISIBLE|WS_CHILD, 590, 640, 150, 30, hwnd, (HMENU)IDC_BUTTON14, hInstance, 0);
	orgbuttonproc14 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton15 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "SM Top", WS_VISIBLE|WS_CHILD, 740, 640, 150, 30, hwnd, (HMENU)IDC_BUTTON15, hInstance, 0);
	orgbuttonproc15 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton16 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "SM Bottom", WS_VISIBLE|WS_CHILD, 890, 640, 150, 30, hwnd, (HMENU)IDC_BUTTON16, hInstance, 0);
	orgbuttonproc16 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	
	bouton17 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "Inspector", WS_VISIBLE|WS_CHILD, 440, 670, 150, 30, hwnd, (HMENU)IDC_BUTTON17, hInstance, 0);
	orgbuttonproc17 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton18 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "Not Assigned", WS_VISIBLE|WS_CHILD, 590, 670, 150, 30, hwnd, (HMENU)IDC_BUTTON18, hInstance, 0);
	orgbuttonproc18 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton19 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "Not Assigned", WS_VISIBLE|WS_CHILD, 740, 670, 150, 30, hwnd, (HMENU)IDC_BUTTON19, hInstance, 0);
	orgbuttonproc19 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	bouton20 = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "Not Assigned", WS_VISIBLE|WS_CHILD, 890, 670, 150, 30, hwnd, (HMENU)IDC_BUTTON20, hInstance, 0);
	orgbuttonproc20 = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);

	formode = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "For Mode", WS_VISIBLE|WS_CHILD, 440, 700, 150, 30, hwnd, (HMENU)IDC_BUTTON_FOR_MODE, hInstance, 0);
	orgbuttonprocfmod = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	
	//Pour parametrer la camera
	hwndup = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "UP", WS_VISIBLE|WS_CHILD, 1100, 550, 50, 50, hwnd, (HMENU)IDC_UP, hInstance, 0);
	orgUp = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc); 
	hwnddown = CreateWindowEx(WS_EX_CLIENTEDGE,	"BUTTON", "DOWN", WS_VISIBLE|WS_CHILD, 1100, 650, 50, 50, hwnd, (HMENU)IDC_DOWN, hInstance, 0);
	orgDown = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc); 
	hwndright = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "RIGHT", WS_VISIBLE|WS_CHILD, 1150, 600, 50, 50, hwnd, (HMENU)IDC_RIGHT, hInstance, 0);
	orgRight = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	hwndleft = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "LEFT", WS_VISIBLE|WS_CHILD, 1040, 600, 50, 50, hwnd, (HMENU)IDC_LEFT, hInstance, 0);
	orgLeft = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	hwndplus = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "+", WS_VISIBLE|WS_CHILD, 1200, 550, 30, 30, hwnd, (HMENU)IDC_ZOOM_IN, hInstance, 0);
	orgPlus = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);
	hwndmoins = CreateWindowEx(WS_EX_CLIENTEDGE, "BUTTON", "-", WS_VISIBLE|WS_CHILD, 1200, 580, 30, 30, hwnd, (HMENU)IDC_ZOOM_OUT, hInstance, 0);
	orgMoins = (WNDPROC) SetWindowLong(hwnd, GWL_WNDPROC, (LONG) evenementproc);

}
