#ifndef INTERFACE_H
#define INTERFACE_H
#include <stdlib.h>
#include <string>
#include <Inventor/SbLinear.h>
#include <jni.h>


HINSTANCE	hInstance = (HINSTANCE)0x00400000;
HANDLE		hImage;

char*		CurrentDir = "animation/";
char*		CurrentDir2 = "spatialawarness/Name_Camera/";
char*		CurrentDir3 = "spatialawarness/Name_Object/";
char*		CurrentDir4 = "C://CanadarmTutor/GOTO/Goal/";
char*		CurrentDir5 = "cameras/";
char*		PlanFile = CurrentDir4 ;


HWND		hwndMonitor1, hwndMonitor2, hwndMonitor3;
//compteur pour initialiser la vue dans la fentre voulue
int			compteur = 1;

HWND		vincenttestbutton;		
HWND		hwnd, hwndChild1, hwndChild2, hwndChild3, hwndTrace,hwndTitreTrace,hwndState1,hwndState2,hwndState3;
HWND		hwndAction, hwndApplied, hwndResult, hwndNotes;
HWND		boutonChangementFenetre, boutonCamera, hwndActivation;

// 20 boutons pour 20 cameras
HWND		bouton1, bouton2, bouton3, bouton4, bouton5;
HWND		bouton6, bouton7, bouton8, bouton9, bouton10;
HWND		bouton11, bouton12, bouton13, bouton14, bouton15;
HWND		bouton16, bouton17, bouton18, bouton19, bouton20;

//bouton pour la barre d'outils
HWND		bouton_help, bouton_tuteur, bouton_mode;
// boutons pour parametriser le zoom des cameras
HWND		hwndplus1, hwndmoins1, hwndplus2, hwndmoins2, hwndplus3, hwndmoins3;

//***boite de dialogue movie generator***//
HWND		hwndMovieGenerator;
HWND		hwndNumS;
HWND		hwndTexteSNum, hwndSNum;
HWND		hwndTexteSeq, hwndSeq;
HWND		hwndTexteMonitor1, hwndListeWind1, hwndTexteMonitor2, hwndListeWind2, hwndTexteMonitor3, hwndListeWind3;
HWND		hwndListeAnim, hwndNameAnim;
HWND		hwndPreviousMG, hwndNextMG; 
int			enregistrement_courant = 0;

//bar d'outils
HWND		hToolbar;

//boite de dialigue path planner
HWND		hwndPathPlanner;

//boite de dialogue Load de movie generator
HWND		hwndLoad, hwndFichier, hwndListeFichier;
int			SelIndex;  // Indexe de l'item
int			SelLen;    // Nombre de caractre de l'item
char		*buffer;  // Variable temporaire

//boite de dialogue Save as de movie generator
HWND		hwndSave, hwndFichier2;
HMENU		menuMovieGenerator;

//Pour recuperer les champs de movie generator
typedef struct{
	int camM1;
	int camM2;
	int camM3;
	int cur;
	int max;
}Config_t;

Config_t tmp;

int save_file = 0;
int cs1, cs2, cs3;
int cameraListMonitor1[20];
int cameraListMonitor2[20];
int cameraListMonitor3[20];

char nomAnim[20];
char ns[10];
int ns1;
char sn[10];
int sn1;
//char cs[20];
//   int cs1;
char ts[10];
int ts1;

//for the path for the file
char* current;

//***boite de dialogue task editor***//
HWND		hwndTaskEditor;

//***fenetre de tutoring***//
HWND		hwndTutor;

HWND		hwndTraceWindow,hwndCollision, hwndDD,hwndTitreCollision,hwndProximity,hwndTitreProximity;
HWND		hwndTextCollision, hwndTextDD;

//***spatial awarness***//
//name
HWND		hwndSpatAwar, hwndQuestionList, hwndAnswer, hwndCourse, hwndScore, hwndAnswerList, hwndCameraName;

//name and select
HWND		hwndSpatAwar2, hwndQuestionList2, hwndAnswer2, hwndCourse2, hwndScore2, hwndAnswerList2, hwndListCameraSpa2;

//fenetre servant  l'affichage de la station pour spatial awareness et pour montrer des animations
HWND		hwndPhoto;

char*		camera_name;
char*		object_name;
HMENU		menuSpatialAwareness;
ifstream	CourseFile;

char        allQuestion[20][256];
char        Name_Object[20][256];
char		totalQuestion[260];
int*		given_answer;
int			selection_courante3=0;
int			selection_courante4=0;
int			enregistrement;
char		cameraList[20][3];
char		answer[20][256];
char		currentAnswer[30];
int			currentQuestion;
char		*charScore;
char		bufferScore[5];
char		bufferTotalScore[5];
int			score = 0;
char		xPl[20][15], yPl[20][15], zPl[20][15], xOl[20][15], yOl[20][15], zOl[20][15], anglel[20][15], aRl[20][15], nDl[20][15], faDl[20][15], foDl[20][15], hAl[20][15];

//camera avant l'animation doivent etre accessible aux threads
static char		camera_animation1[30];
static char		camera_animation2[30];
static char		camera_animation3[30];

//***pour nommer les cameras courantes***//
HWND		camSel1, camVal1, camSel2, camVal2, camSel3, camVal3, camSel4, camVal4;

//***Goto Goal***//
HWND		hwndGotoGoal, hwndQuestionList3, hwndSession, hwndAnswerGTG, hwndCourseGTG, hwndScoreGTG, hwndAnswerListGTG;


char        notallQuestion[20][10];
HMENU		menuPayloadMove;
char        NextGoal_x[20][10];
char        NextGoal_y[20][10];
char        NextGoal_z[20][10];

int         goal_x;
int         goal_y;
int         goal_z;
char        position[20];

int			selection_courante5=0;
int			selection_courante6=0;

char		Position[256];

int step=0;
int currentPosition =0;
int enregistrement1;

//Pour desactiver le bouton create
int			traite = 0;

HMENU		menuPrincipal;
HMENU		camMenu;
POINT		pt;

//how to see
HWND		hwndHowToSee, hwndfenHTS, hwndListeCameraNameHTS, hwndNomCameraCourante,hwndObstacletosee,hwndRefresh;
char		NameCameraFile[50];

typedef struct{
	char nom[20];
	float xPos;
	float yPos;
	float zPos;
	float xOr;
	float yOr;
	float zOr;
	float angle;
	float aR;
	float nD;
	float faD;
	float foD;
	float hA;
}listeCamera_t;

listeCamera_t listeCamera[17];

//what if action go to goal
HWND		hwndResetEE;
//pour la sauvegarde du EE
mpkConfig qCourant(8);


//what if select camera
HWND		hwndWhatCamera, hwndFenWhatCamera;

//fenetre milestone
HWND		hwndWhatMilestones;
HWND		hwndabout;

#define IDC_CAMSEL1 136
#define IDC_CAMSEL2 137
#define IDC_CAMSEL3 138
#define IDC_EE 139
#define IDC_WE 140
#define IDC_SE 141
#define IDC_LT 142
#define IDC_LB 143
#define IDC_LBA 144
#define IDC_SF 145
#define IDC_SB 146
#define IDC_ZF 147
#define IDC_ZB 148
#define IDC_SRF 149
#define IDC_SRB 150
#define IDC_SLF 151
#define IDC_SLB 152
#define IDC_ST 153
#define IDC_SBO 154
#define IDC_I 155
#define IDC_ZOOM_IN 156
#define IDC_ZOOM_OUT 157
#define IDC_CAMVAL1 158
#define IDC_CAMVAL2 159
#define IDC_CAMVAL3 160
#define IDC_PLUS1 161
#define IDC_MOINS1 162
#define IDC_PLUS2 163
#define IDC_MOINS2 164
#define IDC_PLUS3 165
#define IDC_MOINS3 166
#define ID_TOOLBAR 167
#define IDC_BARTOOL1 173
#define IDC_BARTOOL2 174
#define IDC_BARTOOL3 175
#define IDC_CAMSET	176
#define IDC_TRACEWINDOW 177
#define IDC_COLLISION 178
#define IDC_DD 179


HANDLE* hThread = 0;
int selection_courante = 0;
int selection_courante2 = 0;
int courant = 1;
int temps_tmp = 0;
int* real_time;
int first_time = 0;
//Pour stocker les param du fichier animation
int* camAnim;
int* timeAnim;
int* window;
char redessine = 'y';
Config_t* conf;
ofstream f;
int edition = 1;
char* camera_animation;

//Pour lister le repertoire
char Chemin[MAX_PATH];
WIN32_FIND_DATA wData;
HANDLE listing;

char* tmpFile;
int directory = 0;


WNDPROC vincenttestbtnproc;
WNDPROC orgbuttonproc1, orgbuttonproc2, orgbuttonproc3, orgbuttonproc4, orgbuttonproc5;
WNDPROC orgbuttonproc6, orgbuttonproc7, orgbuttonproc8, orgbuttonproc9, orgbuttonproc10;
WNDPROC orgbuttonproc11, orgbuttonproc12, orgbuttonproc13, orgbuttonproc14, orgbuttonproc15;
WNDPROC orgbuttonproc16, orgbuttonproc17, orgbuttonproc18, orgbuttonproc19, orgbuttonproc20;
WNDPROC orgbuttonprocFen, orgbuttonprocCam, orgbuttonprocZoom, orgprocMenu, orgprocMenu2;
WNDPROC wind1, wind2, wind3;
WNDPROC orgPlus1, orgMoins1, orgPlus2, orgMoins2, orgPlus3, orgMoins3;
int tr = 1;


//barre d'outils
//Identifiant pour la barre d outils
enum {
	//ID_TOOLBAR_BTN_1,
	ID_TOOLBAR_FOR,
	//ID_TOOLBAR_BTN_3,
	ID_TOOLBAR_REFERENCE,
	//ID_TOOLBAR_BTN_5,
	ID_TOOLBAR_ZONE,
	//ID_TOOLBAR_BTN_7,
	ID_TOOLBAR_TRACE,
	//ID_TOOLBAR_BTN_8,
	ID_TOOLBAR_COLLISION,
	//ID_TOOLBAR_BTN_9,
	ID_TOOLBAR_DD,
	NB_TOOLBAR_BTN
};



//Composition de la barre d outils
static TBBUTTON tbbtn[]= {
	//{ID_TOOLBAR_BTN_1, ID_TOOLBAR_BTN_1, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
	{ID_TOOLBAR_FOR, ID_TOOLBAR_FOR, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
	//{ID_TOOLBAR_BTN_3, ID_TOOLBAR_BTN_3, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
	{ID_TOOLBAR_REFERENCE, ID_TOOLBAR_REFERENCE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
	//{ID_TOOLBAR_BTN_5, ID_TOOLBAR_BTN_5, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
	{ID_TOOLBAR_ZONE, ID_TOOLBAR_ZONE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
	//{ID_TOOLBAR_BTN_7, ID_TOOLBAR_BTN_7, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
	{ID_TOOLBAR_TRACE, ID_TOOLBAR_TRACE, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
	//{ID_TOOLBAR_BTN_8, ID_TOOLBAR_BTN_8, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
	{ID_TOOLBAR_COLLISION, ID_TOOLBAR_COLLISION, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0},
	//{ID_TOOLBAR_BTN_9, ID_TOOLBAR_BTN_9, TBSTATE_ENABLED, TBSTYLE_SEP, 0L, 0},
	{ID_TOOLBAR_DD, ID_TOOLBAR_DD, TBSTATE_ENABLED, TBSTYLE_BUTTON, 0L, 0}
};

static int nHauteur_Caractere = 20;
static int nLargeur_Caractere = 10;
static int nOrientation_Caractere = 0; 
static char* Police_Utile = "Arial";

// pour regler les pb de la barre d'outils
int debut = 0;

// pour la pyramide du monitor1
SbViewVolume volumeCamera1;
SbPlane planCam1[6];
//float vertices1[8][3];
SoCoordinate3 *myCoords1;
SoFaceSet* pyramide1;

float x1Cam1, y1Cam1, z1Cam1;
float x2Cam1, y2Cam1, z2Cam1;
float x3Cam1, y3Cam1, z3Cam1;
float x4Cam1, y4Cam1, z4Cam1;
float x5Cam1, y5Cam1, z5Cam1;
float x6Cam1, y6Cam1, z6Cam1;
float x7Cam1, y7Cam1, z7Cam1;
float x8Cam1, y8Cam1, z8Cam1;

// pour la pyramide du monitor2
SbViewVolume volumeCamera2;
SbPlane planCam2[6];
//float vertices2[8][3];
SoCoordinate3 *myCoords2;
SoFaceSet* pyramide2;

float x1Cam2, y1Cam2, z1Cam2;
float x2Cam2, y2Cam2, z2Cam2;
float x3Cam2, y3Cam2, z3Cam2;
float x4Cam2, y4Cam2, z4Cam2;
float x5Cam2, y5Cam2, z5Cam2;
float x6Cam2, y6Cam2, z6Cam2;
float x7Cam2, y7Cam2, z7Cam2;
float x8Cam2, y8Cam2, z8Cam2;

// pour la pyramide du monitor3
SbViewVolume volumeCamera3;
SbPlane planCam3[6];
//float vertices3[8][3];
SoCoordinate3* myCoords3;
SoFaceSet* pyramide3;

float vertices1[4][3];
float vertices2[4][3];
float vertices3[4][3];
float vertices4[4][3];
float vertices5[4][3];
float vertices6[4][3];

float vertices7[4][3];
float vertices8[4][3];
float vertices9[4][3];
float vertices10[4][3];
float vertices11[4][3];
float vertices12[4][3];

float vertices13[4][3];
float vertices14[4][3];
float vertices15[4][3];
float vertices16[4][3];
float vertices17[4][3];
float vertices18[4][3];

float verticesReset[4][3];

float x1Cam3, y1Cam3, z1Cam3;
float x2Cam3, y2Cam3, z2Cam3;
float x3Cam3, y3Cam3, z3Cam3;
float x4Cam3, y4Cam3, z4Cam3;
float x5Cam3, y5Cam3, z5Cam3;
float x6Cam3, y6Cam3, z6Cam3;
float x7Cam3, y7Cam3, z7Cam3;
float x8Cam3, y8Cam3, z8Cam3;

void ajouter_texte(HWND fenetre, const char* texte);
void EnvoieMessages(const char* message);
//JNIEXPORT void JNICALL ReceptionMessage(JNIEnv *env1, jobject obj1, jstring message);
const char* concat(char* c1);
char* nomScene;

bool afficheTrace = false;
bool afficheCollision = false;
bool afficheprox = false;
SbViewVolume volumeCameraSpatial;

#endif