#ifndef VISIBLE_H
#define VISIBLE_H

#include <vector>
#include <Inventor/Win/viewers/SoWinViewer.h>
#include <Inventor/Win/viewers/SoWinFullViewer.h>//ajout
#include <Inventor/SbLinear.h>
#include <Inventor/SoDB.h>
#include <Inventor/SoInput.h>
#include <Inventor/nodes/SoBlinker.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/Win/SoWinRenderArea.h>
#include "mpk_inventor.h"
#include "mpkRobotCollection.H"
#include "mpkObstacleCollection.H"
#include "mpkZoneCollection.H"
#include <GL/gl.h>
#include <GL/glu.h>
//#include "mpkGUI.h"

/**@memo Pour pouvoir lire le z buffer, on doit redefinir la methode proteg actualRedraw de SoWinExaminerViewer
 */
class visible: public SoWinExaminerViewer{

public:
	visible(HWND parent):SoWinExaminerViewer(parent){;}
protected:
	virtual void actualRedraw(void);
  
};

#endif