#ifndef _DecoupObstacles
#define _DecoupObstacles

#include <cstdlib>
#include <cmath>
#include <vector>
#include "Global.h"
#include "Configuration.h"
#include "Constantes.h"
#include "Functions.h"
#include "GroupDensite.h"
//#include "mpkObstacleCollection.h" // donne ttes les infos sur les modeles des obstacles
//mpkObstacleCollection::pqp et mpkObstacleCollection::Tr --> ok pr param et matrices, restera juste positions

// generateur aleatoire gaussien simple :
double gaussRand(double mean,double stdDev);

// chantillonnage gaussien autour d'une configuration
void gauss_sample(double sigma,double* pointTest);

// calcule la distance (presque) exacte d'un point 3D  une configuration 8D du bras robot
double distance(double* point);

// cas ou la trajectoire est connue :
void analyseObstacles(const vector<Configuration>& configurations);

// cas ou la trajectoire est imprevisible :
void analyseObstaclesImp();

#endif
