#include "Zone.h"

// fonction disant si un point 3D est dans la zone :
bool Zone::isInside(double* point) {

	if (point[2]<z1 || point[2]>z2) return false;
	if (point[0]==0.0 && ((point[1]>0 && (phi1>M_PI_2 || phi2<M_PI_2))
					|| (point[1]<0 && (phi1>-M_PI_2 || phi2<-M_PI_2)))) return false;

	double angle;
	if (point[0]!=0.0) {
		if (point[1]!=0.0) {
			angle=atan(point[1]/point[0]);
			// attention angle n'est pas valide dans le cas ou l'on n'est pas dans la partie droite du cadran :
			if (point[0]<0.0) {
				if (point[1]<0.0) angle-=M_PI;
				else angle+=M_PI;
			}
		}
		else {
			if (point[0]<0.0) angle=M_PI;
			else angle=0.0;
		}
	}
	else {
		if (point[1]<0.0) angle=-M_PI_2;
		else angle=M_PI_2; // inclus le cas ou x=y=0 (alors angle arbitraire)
	}
	if (angle<phi1 || angle>phi2) return false;

	double rad=sqrt(point[0]*point[0]+point[1]*point[1]);
	if (rad<rad1 || rad>rad2) return false;
	return true;
}
