#ifndef _Constantes
#define _Constantes

// doubles :
#define RAY_C 2.7 // rayon de la coupe d'un cylindre de bras (inutilise car PQP)
#define RAY_P 10.0 // rayon de la sphere modelisant le poignet (inutilise car PQP)
#define LONG_EC 130.0 // longueur de l'epaule au coude : 8.5m
#define LONG_CP 130.0 // longueur du coude au poignet : 8.5m
#define PAS_ELEM 1.0 // OK (inutilise car PQP)
#define COEFF_EP 5 // OK (pour calcul centre de gravite)
#define COEFF_CO 5 // OK
#define COEFF_PO 1 // OK
#define MAX_DIST 100000000 // OK
#define CHAMP_POIGNET 30.0 // champ de vision du poignet (==diametre, en unites RT)
#define ANGLE_CAM M_PI_4 // demi-angle de vue de chaque camera; OK pr cameras virtuelles; Corriger si fixes..
#define TAN_ANGLE 1.0 // idem
#define TAN_2_ANGLE 1.0 // idem
#define MARGE_VUE 4.0 // OK
#define MARGE_VUE_IDIOMS 4.0 // plus large car sinon bout de bras hors-champ; a ameliorer !!
#define SEUIL_JOINT 0.001 // seuil de variation effective dans le mouvement des joints;
#define EPSILON_BEN 0.2 // seuil de fusion des segments dans DecoupMonotone.cpp
#define S_MIN 10.5 // inutilise (car PQP plus rapide)
#define S_MAX 30.5 // inutilise (car PQP plus rapide)
#define S_INC 5.0 // inutilise (car PQP plus rapide)
#define SEUIL_OBST 5.0 // seuil pr distance a la moyenne dans DecoupObstacles.cpp  ajuster......
#define SEUIL_DIST_OBST 2.0 // seuil pr distance seuil au-dela de laquelle on zoome dans DecoupObstacles.cpp  ajuster......
#define SEUIL_LISS 0.05 // seuil == frontiere deplacement / saut
#define SEUIL_PREDOM 0.9999 // seuil de predominance pour depct_negligeable / depct_remarquable dans TransfIdioms.cpp
#define SEUIL_VIS_INIT 0.9 // seuil de visibilite dans PlaceCamera.cpp, initialisation (tres contraint)
#define SEUIL_VIS_ADJUST 0.6 // seuil de visibilite dans PlaceCamera.cpp, ajustement (souple)
#define SEUIL_VIS_FIXE 0.4 // seuil de visibilite dans FilmageFixe.cpp (tres bas pour frame coherence..)
#define M_PI 3.141592653589793238462643383279
#define M_PI_2 1.570796326794896619231321691639
#define M_PI_4 0.785398163397448309615660845819
#define SEUIL_TOL 0.0001 // seuil pr precision ==0

// entiers :
#define DIM  8
#define E_PTS 50 // inutilise dans DecoupObstacles.cpp (car PQP plus rapide), mais utile dans Camera.cpp
#define C_PTS 50 // idem
#define P_PTS 20 // idem
#define MAX_TRIAL_VIS 100 // OK
#define IM_SEC 24 // OK
#define NB_ECH_PTS 13 // OK
#define NB_CAMS 11 // normalement 14, mais que 11 dans RT
#define NB_VIEWS 7 // nombre de vue differentes preexistantes

#endif
