#ifndef _DecoupObstacles
#define _DecoupObstacles

#include <cstdlib>
#include <cmath>
#include <vector>
#include "Global.h"
#include "mpkConfig.h"
#include "Constantes.h"
#include "Functions.h"
#include "GroupDensite.h"
#include "PQP.h"
#include "mpkObstacleCollection.H"
#include "mpkRobotCollection.H"
#include "mpkConfigChecker.H"

// generateur aleatoire gaussien simple :
double gaussRand(double mean,double stdDev);

// chantillonnage gaussien autour d'une configuration
void gauss_sample(double sigma,double* pointTest);

// calcule la distance (presque) exacte d'un point 3D  la configuration 8D du bras robot
double distance(double* point);

// cas ou la trajectoire est connue :
void analyseObstacles(vector<mpkConfig>& configurations);

// cas ou la trajectoire est imprevisible :
void analyseObstaclesImp(mpkConfig& configC);

#endif
