#ifndef _ZonesToIdioms
#define _ZonesToIdioms

#include <cstdlib>
#include <cmath>
#include <vector>
#include "Global.h"
#include "Constantes.h"
#include "Functions.h"
#include "Zone.h"
#include "Idiom.h"
#include "mpkConfig.h"

using namespace std;

// fonction effectuant le decoupage de la trajectoire selon les zones visitees,
// et retournant la suite d'idiomes correspondante
vector<Idiom> idiomsFromZones(const vector<mpkConfig>& configurations);

#endif
