#include "movieGenerator.h"

int movieGenerator::getCam(char* cs){
	
	if(strcmp(cs, "EE")==0)return 1;
	else if(strcmp(cs, "WE")==0)return 2;
	     else if(strcmp(cs, "SE")==0)return 3;
			  else if(strcmp(cs, "Lab Top")==0)return 4;
				   else if(strcmp(cs, "Lab Bottom")==0)return 5;
						else if(strcmp(cs, "Lab Back")==0)return 6;
							 else if(strcmp(cs, "SPP Front")==0)return 7;
								  else if(strcmp(cs, "SPP Back")==0)return 8;
									   else if(strcmp(cs, "ZCM Front")==0)return 9;
										    else if(strcmp(cs, "ZCM Back")==0)return 10;
												 else if(strcmp(cs, "SP Right Front")==0)return 11;
													  else if(strcmp(cs, "SP Right Back")==0)return 12;
														   else if(strcmp(cs, "SP Left Front")==0)return 13;
																else if(strcmp(cs, "SP Left Back")==0)return 14;
																     else if(strcmp(cs, "SM Top")==0)return 15;
																		  else if(strcmp(cs, "SM Bottom")==0)return 16;
																			   else if(strcmp(cs, "Perspective")==0)return 17;
	
	
}

int movieGenerator::getWin(char* win){
	if(strcmp(win, "Left")==0)return 1;
	else if(strcmp(win, "Middle")==0)return 2;
	     else if(strcmp(win, "Right")==0)return 3;
}

int movieGenerator::getTime(char* ts){
	return(atoi(ts));
}

//num of shot appear first
//we erase the preview record
void movieGenerator::writeFile(char *fname, int numShot)
{
	ofstream f(fname);
	if (!f) return;
	f << numShot << "\n";
	f.close();
}

//we append the camera list
void movieGenerator::writeFile(char *fname, int* camMonitor1, int* camMonitor2, int* camMonitor3, int numShot){
    
	ofstream f(fname, ios_base::app);
	if (!f) return;
	for(int i=0; i<numShot; i++){
        f << camMonitor1[i] << "\n";
        f << camMonitor2[i] << "\n"; 
        f << camMonitor3[i] << "\n"; 
	}
	f.close();
}

//read just the number of shot
void movieGenerator::readFile(char* animation, int* numshot){
	ifstream Fichier (animation ,ios::in );
	printf("%s\n", animation);
	if(!Fichier){ 
	cerr<<"Cannot Open File "<< animation <<endl;
	printf("prob  l'ouverture du fichier\n");
	return; 
	} 
	
	Fichier>> *numshot;
	Fichier.close();
}

void movieGenerator::readFile(char* animation, int* camMonitor1, int* camMonitor2, int* camMonitor3, int numshot){

    ifstream Fichier (animation ,ios::in );
	if(!Fichier){ 
	cerr<<"Cannot Open File "<< animation <<endl;
	printf("prob  l'ouverture du fichier\n");
	return; 
	} 
	int i=0;

	Fichier>> numshot;
    
	while (!Fichier.eof()&& i<numshot){ 
        
		Fichier>> camMonitor1[i];
        Fichier>> camMonitor2[i];
        Fichier>> camMonitor3[i];
		i++;
   }
	Fichier.close();
}

//read all the file
void movieGenerator::readFile(char* animation, int* camMonitor1, int* camMonitor2, int* camMonitor3, int* numshot){

	ifstream Fichier (animation ,ios::in );
	if(!Fichier){ 
	cerr<<"Cannot Open File "<< animation <<endl;
	printf("prob  l'ouverture du fichier\n");
	return; 
	} 
	int i=0;

	Fichier>> *numshot;
    
	while (!Fichier.eof()&& i<*numshot){ 
        
		Fichier>> camMonitor1[i];
        Fichier>> camMonitor2[i];
        Fichier>> camMonitor3[i];
		i++;
   }
	Fichier.close();
}

void movieGenerator::select_Camera(SoPerspectiveCamera *cam, int numCam){
		switch(numCam){
			case 1:
				camera::set_camParam(cam, 569.261, -1064.881, 136.206, -0.701, -0.537, -0.467, 4.366, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 2:
				camera::set_camParam(cam, -748.062, 68.959, 966.803, -0.296, 0.487, 0.821, 3.717, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 3:
                camera::set_camParam(cam, -50.777, 215.241, 515.984, 0.067, -0.584, -0.808, 3.055, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 4:
				camera::set_camParam(cam, -1032.37,109.504,-1256.63,-0.832051,-0.527537,0.171451,2.46068, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 5:
				camera::set_camParam(cam, 580.308, -242.302, -486.075, -0.955, 0.206, -0.210, 2.112, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 6:
				camera::set_camParam(cam, -1282.575, 6.707, 1164.792, 0.434, -0.547, -0.714, 1.737, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 7:
				camera::set_camParam(cam, -397.189, -1096.033, -147.606, 0.547, 0.755, -0.360, 3.590, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 8:
				camera::set_camParam(cam, 258.061,-361.047,-278.987,-0.999393,0.0323814,0.0128793,1.91291, 1.0, 0.1, 0.1, 0.1, 0.5);
                break;
			case 9:
				camera::set_camParam(cam, 952.26,-1588.61,-315.012,0.310087,-0.697314,0.646219,3.6495, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 10:
				camera::set_camParam(cam, 366.834, -84.078, 735.182, -0.729, 0.067, -0.680, 1.390, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 11:
				camera::set_camParam(cam, -236.006,643.066,-349.867,-0.985935,-0.100732,0.133358,1.7867, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 12:
				camera::set_camParam(cam, -210.294,-1641.39,-170.841,-0.056643,-0.746998,0.662409,2.86602, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 13:
				camera::set_camParam(cam, -161.232, 1651.020, 556.812, 0.00154069,-0.690163,-0.723652,2.85893, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 14:
				camera::set_camParam(cam, 250.351,52.9159,48.5513,-0.866738,0.34878,-0.356536,1.63675, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 15:
				camera::set_camParam(cam, 207.413, -297.251, -126.233, -0.592925, 0.60644, -0.529783, 2.13097, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 16:
				camera::set_camParam(cam, -984.277,-143.684,-1060.28,-0.855042,-0.454735,0.249238,2.55066, 1.0, 0.1, 0.1, 0.1, 0.5);
				break;
			case 17:
				camera::set_camParam(cam, 2406.38, 1943.55, -2592.93, -0.904203, 0.40155, -0.145513, 2.29618, 1.0, 1680.3, 6786.44, 4400.13, 0.5);
				break;
			case 18:
				printf("Not assigned\n");
				break;
			case 19:
				printf("Not assigned\n");
				break;
			case 20:
				printf("Not assigned\n");
				break;
			default:
				camera::set_camParam(cam, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
		}
	}

//not used
void movieGenerator::makeAnim(int* win, int* cam, int* time, int numShot){

	
	for(int i = 0; i<numShot; i++){
		struct _timeb depart, fin;
		
		_ftime(&depart);
		_ftime(&fin);
		switch(win[i])
		{
		case 1:
			while(difftime(fin.time, depart.time)<(double)time[i]){
            select_Camera(mpkGUI::rootCamera1, cam[i]);
            mpkGUI::myViewer1->render();
			_ftime(&fin);
			}
			break;
		case 2:
			while(difftime(fin.time, depart.time)<(double)time[i]){
			select_Camera(mpkGUI::rootCamera2, cam[i]);
            mpkGUI::myViewer2->render();
			_ftime(&fin);
			}
			break;
		case 3:
			while(difftime(fin.time, depart.time)<(double)time[i]){
			select_Camera(mpkGUI::rootCamera3, cam[i]);
            mpkGUI::myViewer3->render();
			_ftime(&fin);
			}
			break;
		}
	}	
}

void movieGenerator::makeAnim(int win, int cam){

		switch(win)
		{
		case 1:
            select_Camera(mpkGUI::rootCamera1, cam);
            mpkGUI::myViewer1->render();
			break;
		case 2:
			select_Camera(mpkGUI::rootCamera2, cam);
            mpkGUI::myViewer2->render();
			break;
		case 3:
			select_Camera(mpkGUI::rootCamera3, cam);
            mpkGUI::myViewer3->render();
			break;
		}
}

char* movieGenerator::to_String(int cam){
	if(cam == 1)return "EE";
	else if(cam == 2)return "WE";
	     else if(cam == 3)return "SE";
			  else if(cam == 4)return "Lab Top";
				   else if(cam == 5)return "Lab Bottom";
						else if(cam == 6)return "Lab Back";
							 else if(cam == 7)return "SPP Front";
								  else if(cam == 8)return "SPP Back";
									   else if(cam == 9)return "ZCM Front";
										    else if(cam == 10)return "ZCM Back";
												 else if(cam == 11)return "SP Right Front";
													  else if(cam == 12)return "SP Right Back";
														   else if(cam == 13)return "SP Left Front";
																else if(cam == 14)return "SP Left Back";
																     else if(cam == 15)return "SM Top";
																		  else if(cam == 16)return "SM Bottom";
																			   else if(cam == 17)return "Perspective";
}
